## mingw-w64-vtk-9.3.1-4.src.tar.zst

=== Common/Misc/CMakeLists.txt ===
set(classes
  vtkContourValues
  vtkErrorCode
  vtkExprTkFunctionParser
  vtkFunctionParser
  vtkHeap
  vtkPolygonBuilder
  vtkResourceFileLocator)

# ExprTk uses lots of templates and exceeds object file limits
if (MINGW AND NOT ANDROID) # MINGW is set when cross-compiling for ANDROID, see issue https://gitlab.kitware.com/cmake/cmake/-/issues/22647
  set_property(SOURCE vtkExprTkFunctionParser.cxx APPEND
    PROPERTY
      COMPILE_FLAGS "-Wa,-mbig-obj")
endif ()

vtk_module_add_module(VTK::CommonMisc
  CLASSES ${classes})
vtk_add_test_mangling(VTK::CommonMisc)

=== IO/ExportGL2PS/CMakeLists.txt ===
set(classes
  vtkGL2PSExporter
  vtkOpenGLGL2PSExporter
  )

vtk_object_factory_declare(
  BASE vtkGL2PSExporter
  OVERRIDE vtkOpenGLGL2PSExporter)

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKIOEXPORTGL2PS_EXPORT")

vtk_module_add_module(VTK::IOExportGL2PS
  CLASSES ${classes}
  SOURCES ${vtk_object_factory_source}
  PRIVATE_HEADERS ${vtk_object_factory_header})
vtk_add_test_mangling(VTK::IOExportGL2PS)

=== IO/TecplotTable/CMakeLists.txt ===
set(classes
  vtkTecplotTableReader)

vtk_module_add_module(VTK::IOTecplotTable
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IOTecplotTable)

=== Interaction/Widgets/CMakeLists.txt ===
set(classes
  vtk3DCursorRepresentation
  vtk3DCursorWidget
  vtk3DWidget
  vtkAbstractPolygonalHandleRepresentation3D
  vtkAbstractSplineRepresentation
  vtkAbstractWidget
  vtkAffineRepresentation
  vtkAffineRepresentation2D
  vtkAffineWidget
  vtkAngleRepresentation
  vtkAngleRepresentation2D
  vtkAngleRepresentation3D
  vtkAngleWidget
  vtkAxesTransformRepresentation
  vtkAxesTransformWidget
  vtkBalloonRepresentation
  vtkBalloonWidget
  vtkBezierContourLineInterpolator
  vtkBiDimensionalRepresentation
  vtkBiDimensionalRepresentation2D
  vtkBiDimensionalWidget
  vtkBorderRepresentation
  vtkBorderWidget
  vtkBoundedPlanePointPlacer
  vtkBoxRepresentation
  vtkBoxWidget
  vtkBoxWidget2
  vtkBrokenLineWidget
  vtkButtonRepresentation
  vtkButtonWidget
  vtkCamera3DRepresentation
  vtkCamera3DWidget
  vtkCameraHandleSource
  vtkCameraOrientationWidget
  vtkCameraOrientationRepresentation
  vtkCameraPathRepresentation
  vtkCameraPathWidget
  vtkCameraRepresentation
  vtkCameraWidget
  vtkCaptionRepresentation
  vtkCaptionWidget
  vtkCellCentersPointPlacer
  vtkCenteredSliderRepresentation
  vtkCenteredSliderWidget
  vtkCheckerboardRepresentation
  vtkCheckerboardWidget
  vtkClosedSurfacePointPlacer
  vtkCompassRepresentation
  vtkCompassWidget
  vtkConstrainedPointHandleRepresentation
  vtkContinuousValueWidget
  vtkContinuousValueWidgetRepresentation
  vtkContourLineInterpolator
  vtkContourRepresentation
  vtkContourWidget
  vtkCoordinateFrameRepresentation
  vtkCoordinateFrameWidget
  vtkCurveRepresentation
  vtkDijkstraImageContourLineInterpolator
  vtkDisplaySizedImplicitPlaneWidget
  vtkDisplaySizedImplicitPlaneRepresentation
  vtkDistanceRepresentation
  vtkDistanceRepresentation2D
  vtkDistanceRepresentation3D
  vtkDistanceWidget
  vtkEllipsoidTensorProbeRepresentation
  vtkEqualizerContextItem
  vtkEvent
  vtkFinitePlaneRepresentation
  vtkFinitePlaneWidget
  vtkFixedSizeHandleRepresentation3D
  vtkFocalPlaneContourRepresentation
  vtkFocalPlanePointPlacer
  vtkHandleRepresentation
  vtkHandleWidget
  vtkHoverWidget
  vtkImageActorPointPlacer
  vtkImageCroppingRegionsWidget
  vtkImageOrthoPlanes
  vtkImagePlaneWidget
  vtkImageTracerWidget
  vtkImplicitCylinderRepresentation
  vtkImplicitCylinderWidget
  vtkImplicitImageRepresentation
  vtkImplicitPlaneRepresentation
  vtkImplicitPlaneWidget
  vtkImplicitPlaneWidget2
  vtkLightRepresentation
  vtkLightWidget
  vtkLinearContourLineInterpolator
  vtkLineRepresentation
  vtkLineWidget
  vtkLineWidget2
  vtkLogoRepresentation
  vtkLogoWidget
  vtkMagnifierRepresentation
  vtkMagnifierWidget
  vtkMeasurementCubeHandleRepresentation3D
  vtkOrientationMarkerWidget
  vtkOrientationRepresentation
  vtkOrientationWidget
  vtkOrientedGlyphContourRepresentation
  vtkOrientedGlyphFocalPlaneContourRepresentation
  vtkOrientedPolygonalHandleRepresentation3D
  vtkParallelopipedRepresentation
  vtkParallelopipedWidget
  vtkPlaneWidget
  vtkPlaybackRepresentation
  vtkPlaybackWidget
  vtkPointCloudRepresentation
  vtkPointCloudWidget
  vtkPointHandleRepresentation2D
  vtkPointHandleRepresentation3D
  vtkPointPlacer
  vtkPointWidget
  vtkPolyDataContourLineInterpolator
  vtkPolyDataPointPlacer
  vtkPolyDataSourceWidget
  vtkPolygonalHandleRepresentation3D
  vtkPolygonalSurfaceContourLineInterpolator
  vtkPolygonalSurfacePointPlacer
  vtkPolyLineRepresentation
  vtkPolyLineWidget
  vtkProgressBarRepresentation
  vtkProgressBarWidget
  vtkProp3DButtonRepresentation
  vtkRectilinearWipeRepresentation
  vtkRectilinearWipeWidget
  vtkResliceCursor
  vtkResliceCursorActor
  vtkResliceCursorLineRepresentation
  vtkResliceCursorPicker
  vtkResliceCursorPolyDataAlgorithm
  vtkResliceCursorRepresentation
  vtkResliceCursorThickLineRepresentation
  vtkResliceCursorWidget
  vtkScalarBarRepresentation
  vtkScalarBarWidget
  vtkSeedRepresentation
  vtkSeedWidget
  vtkSliderRepresentation
  vtkSliderRepresentation2D
  vtkSliderRepresentation3D
  vtkSliderWidget
  vtkSphereHandleRepresentation
  vtkSphereRepresentation
  vtkSphereWidget
  vtkSphereWidget2
  vtkSplineRepresentation
  vtkSplineWidget
  vtkSplineWidget2
  vtkTensorProbeRepresentation
  vtkTensorProbeWidget
  vtkTensorRepresentation
  vtkTensorWidget
  vtkTerrainContourLineInterpolator
  vtkTerrainDataPointPlacer
  vtkTextRepresentation
  vtkTexturedButtonRepresentation
  vtkTexturedButtonRepresentation2D
  vtkTextWidget
  vtkWidgetCallbackMapper
  vtkWidgetEvent
  vtkWidgetEventTranslator
  vtkWidgetRepresentation
  vtkWidgetSet
  vtkXYPlotWidget
  )

vtk_module_add_module(VTK::InteractionWidgets
  CLASSES ${classes})
vtk_add_test_mangling(VTK::InteractionWidgets)

=== Rendering/ParallelLIC/CMakeLists.txt ===
set(classes
  vtkMPIPixelTT
  vtkParallelTimer
  vtkPLineIntegralConvolution2D
  vtkPPainterCommunicator
  vtkPPixelTransfer
  vtkPSurfaceLICComposite
  vtkPSurfaceLICInterface)
set(headers
  vtkMPIPixelView.h)

vtk_object_factory_declare(
  BASE vtkSurfaceLICInterface
  OVERRIDE vtkPSurfaceLICInterface)
vtk_object_factory_declare(
  BASE vtkLineIntegralConvolution2D
  OVERRIDE vtkPLineIntegralConvolution2D)
vtk_object_factory_declare(
  BASE vtkSurfaceLICComposite
  OVERRIDE vtkPSurfaceLICComposite)

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKRENDERINGPARALLELLIC_EXPORT")

set(shader_files
  vtkPSurfaceLICComposite_CompFS.glsl)

set(sources)
set(private_headers)
foreach(shader_file IN LISTS shader_files)
  vtk_encode_string(
    INPUT         "${shader_file}"
    HEADER_OUTPUT header
    SOURCE_OUTPUT source)
  list(APPEND sources ${source})
  list(APPEND private_headers ${header})
endforeach()

vtk_module_add_module(VTK::RenderingParallelLIC
  CLASSES ${classes}
  SOURCES ${sources} ${vtk_object_factory_source}
  HEADERS ${headers}
  PRIVATE_HEADERS ${private_headers} ${vtk_object_factory_header})

option(VTK_RENDERINGPARALLELLIC_SURFACELICPAINTER_TIMER "enable parallel timers for the surface lic painter" OFF)
mark_as_advanced(VTK_RENDERINGPARALLELLIC_SURFACELICPAINTER_TIMER)
vtk_deprecated_setting(convolution_default
  VTK_RENDERINGPARALLELLIC_LINEINTEGRALCONVOLUTION2D_TIMER
  VTK_RENDERINGPARALLELLIC_LINEINTEGRALCONVLOLUTION2D_TIMER
  OFF)
option(VTK_RENDERINGPARALLELLIC_LINEINTEGRALCONVOLUTION2D_TIMER "enable parallel timers for the 2d line integral convolution" "${convolution_default}")
mark_as_advanced(VTK_RENDERINGPARALLELLIC_LINEINTEGRALCONVOLUTION2D_TIMER)

if (VTK_RENDERINGPARALLELLIC_SURFACELICPAINTER_TIMER)
  vtk_module_definitions(VTK::RenderingParallelLIC
    PRIVATE
      vtkSurfaceLICPainterTIME)
endif()
if (VTK_RENDERINGPARALLELLIC_LINEINTEGRALCONVOLUTION2D_TIMER)
  vtk_module_definitions(VTK::RenderingParallelLIC
    PRIVATE
      vtkLineIntegralConvolution2DTIME)
endif()
vtk_add_test_mangling(VTK::RenderingParallelLIC)

=== Rendering/UI/CMakeLists.txt ===

set(classes
  vtkGenericRenderWindowInteractor
)

set(headers)
set(nowrap_headers)

# Setup factory overrides and add window system specific render windows.
if (VTK_USE_X)
  # Add some custom overrides
  if (NOT VTK_DEFAULT_RENDER_WINDOW_HEADLESS)
    vtk_object_factory_declare(
      BASE vtkRenderWindowInteractor
      OVERRIDE vtkXRenderWindowInteractor)
  endif ()
  list(APPEND classes vtkXRenderWindowInteractor)
elseif (WIN32)
  # Add some custom overrides
  if (NOT VTK_DEFAULT_RENDER_WINDOW_HEADLESS)
    vtk_object_factory_declare(
      BASE vtkRenderWindowInteractor
      OVERRIDE vtkWin32RenderWindowInteractor)
    vtk_object_factory_declare(
      BASE vtkHardwareWindow
      OVERRIDE vtkWin32HardwareWindow)
  endif ()
  list(APPEND classes vtkWin32HardwareWindow vtkWin32RenderWindowInteractor)
elseif (VTK_USE_COCOA)
  # Add some custom overrides
  if (NOT VTK_DEFAULT_RENDER_WINDOW_HEADLESS)
    vtk_object_factory_declare(
      BASE vtkRenderWindowInteractor
      OVERRIDE vtkCocoaRenderWindowInteractor)
  endif ()
  list(APPEND sources vtkCocoaRenderWindowInteractor.mm)
  list(APPEND headers
    vtkCocoaRenderWindowInteractor.h)
  list(APPEND nowrap_headers
    vtkCocoaMacOSXSDKCompatibility.h)
  # Set specified Objective-C++ flags, if any.
  if (VTK_REQUIRED_OBJCXX_FLAGS)
    set_source_files_properties(
      vtkCocoaRenderWindowInteractor.mm
      PROPERTIES
        COMPILE_FLAGS "${VTK_REQUIRED_OBJCXX_FLAGS}")
  endif ()
elseif (ANDROID)
  # Add some custom overrides
  vtk_object_factory_declare(
    BASE vtkRenderWindowInteractor
    OVERRIDE vtkAndroidRenderWindowInteractor)
  list(APPEND classes vtkAndroidRenderWindowInteractor)
  include_directories("${CMAKE_ANDROID_NDK}/sources/android/native_app_glue")
elseif (APPLE_IOS)
  # Add some custom overrides
  vtk_object_factory_declare(
    BASE vtkRenderWindowInteractor
    OVERRIDE vtkIOSRenderWindowInteractor)
  list(APPEND sources vtkIOSRenderWindowInteractor.mm)
  list(APPEND headers vtkIOSRenderWindowInteractor.h)
  # Set specified Objective-C++ flags, if any.
  if (VTK_REQUIRED_OBJCXX_FLAGS)
    set_source_files_properties(
      vtkIOSRenderWindowInteractor.mm
      PROPERTIES
        COMPILE_FLAGS "${VTK_REQUIRED_OBJCXX_FLAGS}")
  endif ()
else () # use generic
  vtk_object_factory_declare(
    BASE vtkRenderWindowInteractor
    OVERRIDE vtkGenericRenderWindowInteractor)
endif ()

if (VTK_USE_SDL2 OR CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  # Add some custom overrides
  vtk_object_factory_declare(
    BASE vtkRenderWindowInteractor
    OVERRIDE vtkSDL2RenderWindowInteractor)
  list(APPEND classes vtkSDL2RenderWindowInteractor)
  set (intial_cpp_code
    "
    // defaults
    #ifdef __EMSCRIPTEN__
    int use_platform = 0\;
    int use_sdl2 = 1\;
    #else
    int use_platform = 1\;
    int use_sdl2 = 0\;
    #endif
    // Query the enviromental for backend to use.
    if(const char* p = std::getenv(\"VTK_WINDOW_BACKEND\"))
    {
      const std::string backend(p)\;
      if(backend == \"PLATFORM\")
      {
        use_sdl2 = 0\;
        use_platform = 1\;
      }
      else if(backend == \"SDL2\")
      {
        #ifndef VTK_ENABLE_SDL2
        vtkLogF(ERROR,\"SDL2 backend requested but the SDL2 backend was not compiled\")\;
        #else
        use_sdl2 = 1\;
        use_platform = 0\;
        #endif
      }
      else
      {
        vtkLogF(ERROR,\"Unknown backend '%p', using default platform native window\",backend.c_str())\;
      }
    }
      // register the factory before modyfing the overrrides so it is found below
    vtkRenderingUIObjectFactory* renderingUIFactory = vtkRenderingUIObjectFactory::New()\;
    if (renderingUIFactory)
    {
      // vtkObjectFactory keeps a reference to the factory,
      vtkObjectFactory::RegisterFactory(renderingUIFactory)\;
      renderingUIFactory->Delete()\;
    }
    vtkObjectFactory* object_factory\;
    vtkCollectionSimpleIterator osit\;
    for (vtkObjectFactory::GetRegisteredFactories()->InitTraversal(osit)\;
        (object_factory = vtkObjectFactory::GetRegisteredFactories()->GetNextObjectFactory(osit))\;)
    {
      if (object_factory->HasOverride(\"vtkRenderWindowInteractor\"))
      {
        if (use_sdl2 && !use_platform)
        {
          object_factory->SetEnableFlag(use_sdl2, \"vtkRenderWindowInteractor\", \"vtkSDL2RenderWindowInteractor\")\;
          // disable ALL other interactor overrides.
          object_factory->SetEnableFlag(0, \"vtkRenderWindowInteractor\", \"vtkGenericRenderWindowInteractor\")\;
          object_factory->SetEnableFlag(0, \"vtkRenderWindowInteractor\", \"vtkCocoaRenderWindowInteractor\")\;
          object_factory->SetEnableFlag(0, \"vtkRenderWindowInteractor\", \"vtkWin32RenderWindowInteractor\")\;
          object_factory->SetEnableFlag(0, \"vtkRenderWindowInteractor\", \"vtkXRenderWindowInteractor\")\;
        }
      }
    }"
  )
endif()

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKRENDERINGUI_EXPORT"
  EXTRA_INCLUDES "<vtkCollection.h>" "<vtkObjectFactoryCollection.h>" "<vtkLogger.h>" "<cstdlib>"
  INITIAL_CODE ${intial_cpp_code})

vtk_module_add_module(VTK::RenderingUI
  CLASSES ${classes}
  HEADERS ${headers}
  NOWRAP_HEADERS ${nowrap_headers}
  SOURCES ${sources} ${vtk_object_factory_source}
  PRIVATE_HEADERS ${vtk_object_factory_header}
  )

if (VTK_USE_SDL2 OR CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  vtk_module_find_package(PACKAGE SDL2)
  vtk_module_link(VTK::RenderingUI
    PRIVATE
      SDL2::SDL2)
  vtk_module_definitions(VTK::RenderingUI
    PRIVATE VTK_ENABLE_SDL2)
endif ()

if (VTK_USE_X)
  vtk_module_find_package(
    PACKAGE X11)
  vtk_module_link(VTK::RenderingUI
    PUBLIC
      X11::X11)
elseif (VTK_USE_COCOA)
  vtk_module_link(VTK::RenderingUI PUBLIC "-framework Cocoa")
endif ()

if (ANDROID)
  vtk_module_link(VTK::RenderingUI
    PRIVATE
      android)
endif ()

if (APPLE_IOS)
  vtk_module_link(VTK::RenderingUI PUBLIC "-framework UIKit")
endif ()
vtk_add_test_mangling(VTK::RenderingUI)

=== ThirdParty/lzma/vtklzma/CMakeLists.txt ===
# liblzma wrapped for VTK by Quincy Wofford and John Patchett,
# Los Alamos National Laboratory (2017).
# Thanks to Lasse Collin for integration help

if (FALSE) # XXX(kitware): hide subprojects.
project(LZMA VERSION 5.2.5 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LZMA compression library")
endif ()

# XXX(kitware): avoid quoted variable policy warning from CMake.
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID STREQUAL "Clang")
  SET(GNU_COMPATIBLE_COMPILER 1)
ENDIF()

include(TestBigEndian)
include(CheckIncludeFile)
include(CheckTypeSize)
include(ProcessorCount)

test_big_endian(WORDS_BIGENDIAN)

check_include_file("strings.h" HAVE_STRINGS_H)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_include_file("sys/endian.h" HAVE_SYS_ENDIAN_H)
if (HAVE_BYTESWAP_H)
  check_symbol_exists(HAVE_BSWAP_16 "byteswap.h" bswap_16)
  check_symbol_exists(HAVE_BSWAP_32 "byteswap.h" bswap_32)
  check_symbol_exists(HAVE_BSWAP_64 "byteswap.h" bswap_64)
endif ()

check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("limits.h" HAVE_LIMITS_H)
check_include_file("stdbool.h" HAVE_STDBOOL_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_type_size(int16_t INT16_T)
check_type_size(int32_t INT32_T)
check_type_size(int64_t INT64_T)
check_type_size(intmax_t INTMAX_T)
check_type_size(uint8_t UINT8_T)
check_type_size(uint16_t UINT16_T)
check_type_size(uint32_t UINT32_T)
check_type_size(uint64_t UINT64_T)
check_type_size(uintmax_t UINTMAX_T)

check_type_size("short" SIZE_OF_SHORT)
check_type_size("int" SIZE_OF_INT)
check_type_size("long" SIZE_OF_LONG)
check_type_size("long long" SIZE_OF_LONG_LONG)

check_type_size("unsigned short" SIZE_OF_UNSIGNED_SHORT)
check_type_size("unsigned" SIZE_OF_UNSIGNED)
check_type_size("unsigned long" SIZE_OF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZE_OF_UNSIGNED_LONG_LONG)
check_type_size("size_t" SIZE_OF_SIZE_T)

check_type_size("__int64" __INT64)
check_type_size("unsigned __int64" UNSIGNED___INT64)

check_type_size(uintptr_t UINTPTR_T)
IF(NOT HAVE_UINTPTR_T)
  IF("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
    SET(uintptr_t "uint64_t")
  ELSE()
    SET(uintptr_t "uint32_t")
  ENDIF()
ENDIF()

# We will need to add some encoder/decoder checking here
set(HAVE_DECODER_ARM 1)
set(HAVE_DECODER_ARMTHUMB 1)
set(HAVE_DECODER_DELTA 1)
set(HAVE_DECODER_IA64 1)
set(HAVE_DECODER_LZMA1 1)
set(HAVE_DECODER_LZMA2 1)
set(HAVE_DECODER_POWERPC 1)
set(HAVE_DECODER_SPARC 1)
set(HAVE_DECODER_X86 1)
set(HAVE_DECODERS 1)

set(HAVE_ENCODER_ARM 1)
set(HAVE_ENCODER_ARMTHUMB 1)
set(HAVE_ENCODER_DELTA 1)
set(HAVE_ENCODER_IA64 1)
set(HAVE_ENCODER_LZMA1 1)
set(HAVE_ENCODER_LZMA2 1)
set(HAVE_ENCODER_POWERPC 1)
set(HAVE_ENCODER_SPARC 1)
set(HAVE_ENCODER_X86 1)
set(HAVE_ENCODERS 1)

set(HAVE_MF_BT2 1)
set(HAVE_MF_BT3 1)
set(HAVE_MF_BT4 1)
set(HAVE_MF_HC3 1)
set(HAVE_MF_HC4 1)

# Define some checks
set(HAVE_CHECK_CRC32 1)
set(HAVE_CHECK_CRC64 1)
set(HAVE_CHECK_SHA256 1)
set(HAVE_DECODERS 1)

# Performance optimization
set(TUKLIB_FAST_UNALIGNED_ACCESS 1)
# Additional required mangling (var used by liblzma during build)
set(TUKLIB_SYMBOL_PREFIX vtklzma_)

find_package(Threads REQUIRED)
if (CMAKE_USE_WIN32_THREADS_INIT)
  set(MYTHREAD_VISTA 1)
elseif (CMAKE_USE_PTHREADS_INIT)
  set(MYTHREAD_POSIX 1)
else ()
  message(FATAL_ERROR
    "Unsupported threading backend for LZMA.")
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h")
add_definitions(-DHAVE_CONFIG_H)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/api
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/check
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lz
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/simple
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/delta
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/rangecoder
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common)

set(sources
  src/common/tuklib_cpucores.c
  src/common/tuklib_physmem.c
  src/liblzma/check/check.c
  src/liblzma/check/crc32_fast.c
  src/liblzma/check/crc32_table.c
  src/liblzma/check/crc64_fast.c
  src/liblzma/check/crc64_table.c
  src/liblzma/check/sha256.c
  src/liblzma/common/alone_decoder.c
  src/liblzma/common/alone_encoder.c
  src/liblzma/common/auto_decoder.c
  src/liblzma/common/block_buffer_decoder.c
  src/liblzma/common/block_buffer_encoder.c
  src/liblzma/common/block_decoder.c
  src/liblzma/common/block_encoder.c
  src/liblzma/common/block_header_decoder.c
  src/liblzma/common/block_header_encoder.c
  src/liblzma/common/block_util.c
  src/liblzma/common/common.c
  src/liblzma/common/easy_buffer_encoder.c
  src/liblzma/common/easy_decoder_memusage.c
  src/liblzma/common/easy_encoder.c
  src/liblzma/common/easy_encoder_memusage.c
  src/liblzma/common/easy_preset.c
  src/liblzma/common/filter_buffer_decoder.c
  src/liblzma/common/filter_buffer_encoder.c
  src/liblzma/common/filter_common.c
  src/liblzma/common/filter_decoder.c
  src/liblzma/common/filter_encoder.c
  src/liblzma/common/filter_flags_decoder.c
  src/liblzma/common/filter_flags_encoder.c
  src/liblzma/common/hardware_cputhreads.c
  src/liblzma/common/hardware_physmem.c
  src/liblzma/common/index.c
  src/liblzma/common/index_decoder.c
  src/liblzma/common/index_encoder.c
  src/liblzma/common/index_hash.c
  src/liblzma/common/outqueue.c
  src/liblzma/common/stream_buffer_decoder.c
  src/liblzma/common/stream_buffer_encoder.c
  src/liblzma/common/stream_decoder.c
  src/liblzma/common/stream_encoder.c
  src/liblzma/common/stream_encoder_mt.c
  src/liblzma/common/stream_flags_common.c
  src/liblzma/common/stream_flags_decoder.c
  src/liblzma/common/stream_flags_encoder.c
  src/liblzma/common/vli_decoder.c
  src/liblzma/common/vli_encoder.c
  src/liblzma/common/vli_size.c
  src/liblzma/delta/delta_common.c
  src/liblzma/delta/delta_decoder.c
  src/liblzma/delta/delta_encoder.c
  src/liblzma/lzma/fastpos_table.c
  src/liblzma/lzma/lzma2_decoder.c
  src/liblzma/lzma/lzma2_encoder.c
  src/liblzma/lzma/lzma_decoder.c
  src/liblzma/lzma/lzma_encoder.c
  src/liblzma/lzma/lzma_encoder_optimum_fast.c
  src/liblzma/lzma/lzma_encoder_optimum_normal.c
  src/liblzma/lzma/lzma_encoder_presets.c
  src/liblzma/lz/lz_decoder.c
  src/liblzma/lz/lz_encoder.c
  src/liblzma/lz/lz_encoder_mf.c
  src/liblzma/rangecoder/price_table.c
  src/liblzma/simple/arm.c
  src/liblzma/simple/armthumb.c
  src/liblzma/simple/ia64.c
  src/liblzma/simple/powerpc.c
  src/liblzma/simple/simple_coder.c
  src/liblzma/simple/simple_decoder.c
  src/liblzma/simple/simple_encoder.c
  src/liblzma/simple/sparc.c
  src/liblzma/simple/x86.c)

set(private_headers
  src/common/mythread.h
  src/common/sysdefs.h
  src/common/tuklib_common.h
  src/common/tuklib_config.h
  src/common/tuklib_cpucores.h
  src/common/tuklib_integer.h
  src/common/tuklib_physmem.h
  src/liblzma/check/check.h
  src/liblzma/check/crc32_table_be.h
  src/liblzma/check/crc32_table_le.h
  src/liblzma/check/crc64_table_be.h
  src/liblzma/check/crc64_table_le.h
  src/liblzma/check/crc_macros.h
  src/liblzma/common/alone_decoder.h
  src/liblzma/common/block_buffer_encoder.h
  src/liblzma/common/block_decoder.h
  src/liblzma/common/block_encoder.h
  src/liblzma/common/common.h
  src/liblzma/common/easy_preset.h
  src/liblzma/common/filter_common.h
  src/liblzma/common/filter_decoder.h
  src/liblzma/common/filter_encoder.h
  src/liblzma/common/index.h
  src/liblzma/common/index_encoder.h
  src/liblzma/common/memcmplen.h
  src/liblzma/common/outqueue.h
  src/liblzma/common/stream_decoder.h
  src/liblzma/common/stream_flags_common.h
  src/liblzma/delta/delta_common.h
  src/liblzma/delta/delta_decoder.h
  src/liblzma/delta/delta_encoder.h
  src/liblzma/delta/delta_private.h
  src/liblzma/lzma/fastpos.h
  src/liblzma/lzma/lzma2_decoder.h
  src/liblzma/lzma/lzma2_encoder.h
  src/liblzma/lzma/lzma_common.h
  src/liblzma/lzma/lzma_decoder.h
  src/liblzma/lzma/lzma_encoder.h
  src/liblzma/lzma/lzma_encoder_private.h
  src/liblzma/lz/lz_decoder.h
  src/liblzma/lz/lz_encoder.h
  src/liblzma/lz/lz_encoder_hash.h
  src/liblzma/lz/lz_encoder_hash_table.h
  src/liblzma/rangecoder/price.h
  src/liblzma/rangecoder/range_common.h
  src/liblzma/rangecoder/range_decoder.h
  src/liblzma/rangecoder/range_encoder.h
  src/liblzma/simple/simple_coder.h
  src/liblzma/simple/simple_decoder.h
  src/liblzma/simple/simple_encoder.h
  src/liblzma/simple/simple_private.h)

set(headers
  src/liblzma/api/lzma.h
  src/liblzma/api/lzma/base.h
  src/liblzma/api/lzma/bcj.h
  src/liblzma/api/lzma/block.h
  src/liblzma/api/lzma/check.h
  src/liblzma/api/lzma/container.h
  src/liblzma/api/lzma/delta.h
  src/liblzma/api/lzma/filter.h
  src/liblzma/api/lzma/hardware.h
  src/liblzma/api/lzma/index.h
  src/liblzma/api/lzma/index_hash.h
  src/liblzma/api/lzma/lzma12.h
  src/liblzma/api/lzma/stream_flags.h
  src/liblzma/api/lzma/version.h
  src/liblzma/api/lzma/vli.h
  src/liblzma/api/vtk_lzma_mangle.h)

vtk_module_add_module(VTK::lzma
  SOURCES ${sources}
  HEADERS ${headers}
  PRIVATE_HEADERS ${private_headers}
  HEADERS_SUBDIR "vtklzma/src/liblzma/api")
vtk_module_install_headers(
  DIRECTORIES "src/liblzma/api/lzma"
  SUBDIR      "vtklzma/src/liblzma/api")
set_target_properties(lzma
  PROPERTIES
    C_STANDARD 99
    POSITION_INDEPENDENT_CODE 1)

if (BUILD_SHARED_LIBS)
  set_target_properties(lzma
    PROPERTIES
      DEFINE_SYMBOL DLL_EXPORT)
  if (CMAKE_USE_PTHREADS_INIT)
    target_link_libraries(lzma
      PRIVATE
        ${CMAKE_THREAD_LIBS_INIT})
  endif ()
endif ()

=== Common/DataModel/Testing/Python/CMakeLists.txt ===
# set(TestCellGrid_ARGS
#   -D DATA{../Data/Input/dgHex2d.dg}
# )

vtk_add_test_python(
  ImplicitSum.py
#  LineIntersectQuadraticCells.py
  PerlinNoise.py
  SelectionLoop.py
  TestBoxPlaneIntersection.py
  TestCellGrid.py,NO_VALID
  TestComputeBounds.py,NO_DATA,NO_VALID
  TestCopyStructuredData.py,NO_DATA,NO_VALID
  TestGetBounds.py,NO_DATA,NO_VALID
  TestGetBounds2.py,NO_DATA,NO_VALID
  TestNumericArrayImageData.py,NO_DATA,NO_VALID
  TestPartitionedData.py,NO_DATA,NO_VALID
  TestPointInPolygon.py,NO_DATA,NO_VALID
  TestPolyDataGetCellPoints.py,NO_DATA,NO_VALID
  TestQuadricClustering.py
  TestStaticPointLocator.py,NO_DATA,NO_VALID
  TestStaticPointLocator2.py,NO_DATA,NO_VALID
  TestStaticPointLocator2D.py,NO_DATA,NO_VALID
  TestStaticPointLocator3.py,NO_DATA,NO_VALID
  TestStaticPointLocatorWithDataSet.py,NO_DATA,NO_VALID
  TestStarPolygon.py,NO_DATA,NO_VALID
  TestStructuredGrid.py
  TestTemplates.py,NO_DATA,NO_VALID
  headBone.py
  scalarColors.py
  scalarConn.py
  TestConvexPointSet.py
  otherDataSetAttributes.py,NO_DATA,NO_VALID
  quadricCut.py
  quadraticQuadDeriv.py,NO_VALID
  Test3DCellsEvaluatePosition.py,NO_DATA,NO_VALID,NO_OUTPUT
  TestICPTransform.py
  TestMolecule.py,NO_VALID
  TestClipPolyhedra.py
  TestClipPolyLine.py
  TestPolyhedronCutter.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DFull.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DFullGI.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DMask.py,NO_DATA,NO_VALID
  TestHyperTreeGrid2DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DFull.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DMask.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DMandel.py,NO_DATA,NO_VALID
  TestUniformHyperTreeGrid2DFull.py
  TestUniformHyperTreeGrid2DMask.py
  TestUniformHyperTreeGrid2DWithFilters.py,NO_DATA,NO_VALID
  TestUniformHyperTreeGrid3DWithFilters.py,NO_DATA,NO_VALID
  TestHyperTreeGrid3DCursorsMandel.py,NO_DATA,NO_VALID
  )

=== IO/NetCDF/Testing/Python/CMakeLists.txt ===
vtk_add_test_python(
  NetCDFCF2DBounds.py
  NetCDFCFSetOutputType.py
  NetCDFCFSphericalCoords.py
  NetCDFCFUnstructured.py
  NetCDFReader.py
  )

=== IO/OMF/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkIOOMFCxxTests tests
  TESTING_DATA
  TestOMFReader.cxx)

vtk_test_cxx_executable(vtkIOOMFCxxTests tests)

=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/filter/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

set(core_headers
  FieldSelection.h
  Filter.h
  FilterField.h
  MapFieldMergeAverage.h
  MapFieldPermutation.h
  TaskQueue.h
  )
set(core_sources
  FieldSelection.cxx
  FilterField.cxx
  )
set(core_sources_device
  MapFieldMergeAverage.cxx
  MapFieldPermutation.cxx
  Filter.cxx
  )

vtkm_library(
  NAME vtkm_filter_core
  HEADERS ${core_headers}
  SOURCES ${core_sources}
  DEVICE_SOURCES ${core_sources_device}
  USE_VTKM_JOB_POOL
)

add_library(vtkm_filter INTERFACE)

set_target_properties(
  vtkm_filter_core
  PROPERTIES
  UNITY_BUILD ON
  UNITY_BUILD_MODE BATCH
)

target_link_libraries(vtkm_filter PUBLIC INTERFACE
  vtkm_filter_core
  )

vtkm_install_targets(TARGETS vtkm_filter)

=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/filter/image_processing/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
set(image_processing_headers
  ComputeMoments.h
  ImageDifference.h
  ImageMedian.h
  )

set(image_processing_sources
  ComputeMoments.cxx
  ImageDifference.cxx
  ImageMedian.cxx
  )

vtkm_library(
  NAME vtkm_filter_image_processing
  HEADERS ${image_processing_headers}
  DEVICE_SOURCES ${image_processing_sources}
  USE_VTKM_JOB_POOL
)

target_link_libraries(vtkm_filter PUBLIC INTERFACE vtkm_filter_image_processing)

add_subdirectory(worklet)

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>
# Contributor: Mario Emmenlauer <memmenlauer@biodataanalysis.de>

_realname=vtk
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=9.3.1
pkgrel=4
pkgdesc="A software system for 3D computer graphics, image processing and visualization (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.vtk.org/"
msys2_repository_url="https://gitlab.kitware.com/vtk/vtk"
msys2_references=(
  'archlinux: vtk'
  "cpe: cpe:/a:vtk:vtk"
)
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-fontconfig"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-libxml2"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             # "${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             # "${MINGW_PACKAGE_PREFIX}-tk"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp"
             )
optdepends=("${MINGW_PACKAGE_PREFIX}-adios2: I/O ADIOS2"
            "${MINGW_PACKAGE_PREFIX}-boost: InfovisBoost and InfovisBoostGraphAlgorithms modules"
            "${MINGW_PACKAGE_PREFIX}-cgns: CGNS Reader"
            "${MINGW_PACKAGE_PREFIX}-ffmpeg: I/O FFMPEG"
            "${MINGW_PACKAGE_PREFIX}-fontconfig: Fontconfig Rendering"
            "${MINGW_PACKAGE_PREFIX}-gdal: I/O GDAL"
            "${MINGW_PACKAGE_PREFIX}-gl2ps: PS Rendering"
            "${MINGW_PACKAGE_PREFIX}-hdf5: I/O HDF5"
            "${MINGW_PACKAGE_PREFIX}-liblas: I/O LAS"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: I/O MySQL/MariaDB"
            "${MINGW_PACKAGE_PREFIX}-libpng: I/O Images"
            "${MINGW_PACKAGE_PREFIX}-libogg: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libtheora: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libxml2: I/O Infovis"
            "${MINGW_PACKAGE_PREFIX}-netcdf: I/O netCDF"
            "${MINGW_PACKAGE_PREFIX}-opencascade: I/O OCCT"
            "${MINGW_PACKAGE_PREFIX}-openslide: DomainsMicroscopy"
            "${MINGW_PACKAGE_PREFIX}-openturns"
            "${MINGW_PACKAGE_PREFIX}-openvdb: I/O OpenVDB"
            "${MINGW_PACKAGE_PREFIX}-openvr: OpenVR Rendering"
            "${MINGW_PACKAGE_PREFIX}-pdal: I/O PDAL"
            "${MINGW_PACKAGE_PREFIX}-postgresql: I/O PostgreSQL"
            "${MINGW_PACKAGE_PREFIX}-proj: GEOVis"
            "${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib: Matplotlib renderer"
            "${MINGW_PACKAGE_PREFIX}-qt6-base: Qt Rendering"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Qt Qml plugin"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: I/O SQL"
            # "${MINGW_PACKAGE_PREFIX}-tk: TCL bindings, Python Tk widgets"
            "${MINGW_PACKAGE_PREFIX}-unixodbc")
source=(https://www.vtk.org/files/release/${pkgver%.*}/VTK-${pkgver}.tar.gz
        "001-no-exact-version-for-fast_float.patch"
        "002-Fix-build-with-gcc-13.patch"
        "003-fix-build-with-fmt-11.patch"
        "004-accept-future-versions-of-boost-and-occ.patch"
        "007-dll-export-some-functions.patch"
        "008-Fix-vtkm_openmp-exported-target.patch")
sha256sums=('8354ec084ea0d2dc3d23dbe4243823c4bfc270382d0ce8d658939fd50061cab8'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '20733e97ccf9b0a8e615c75936ce5e4c1db0ac00e9cac30bc359d5912da38990'
            '7c15ee91447c9199dafaa32eb3cf6afbf16e6306b7879a2dcd9f4ebc95c2e75e'
            'a44b3ba4bdc02be4767ff48b8a7fd4206a53756a881421fca99f538b08a7b48c'
            'a9b9292be90c259f0aa058e3f4a7a08b6218f20e6cb2a71e214acda2d2302a50'
            '988ef1d43dadf1da157fc69398f545c6d2e82d2dabd7cb830e9fba9ebaba34ac')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-no-exact-version-for-fast_float.patch \
    002-Fix-build-with-gcc-13.patch \
    003-fix-build-with-fmt-11.patch \
    004-accept-future-versions-of-boost-and-occ.patch \
    008-Fix-vtkm_openmp-exported-target.patch

  # Succeed with Clang but failed with GCC!
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      007-dll-export-some-functions.patch
  fi
}

build() {
  mkdir -p ${srcdir}/build-${MSYSTEM} && cd ${srcdir}/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  CFLAGS+=" ${CPPFLAGS}"
  CXXFLAGS+=" ${CPPFLAGS} -D_USE_MATH_DEFINES -Wno-attributes -Wno-ignored-attributes -Wno-deprecated-declarations"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    "${_extra_config[@]}" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_INSTALL_LICENSEDIR=share/licenses/vtk \
    -DBUILD_SHARED_LIBS=ON \
    -DPython3_EXECUTABLE="${MINGW_PREFIX}/bin/python.exe" \
    -DVTK_BUILD_TESTING=OFF \
    -DVTK_VERSIONED_INSTALL=OFF \
    -DVTK_BUILD_ALL_MODULES=ON \
    -DVTK_GROUP_ENABLE_MPI=NO \
    -DVTK_GROUP_ENABLE_Web=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingOpenXRRemoting=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingZSpace=NO \
    -DVTK_USE_EXTERNAL=ON \
    -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
    -DVTK_WRAP_JAVA=OFF \
    -DVTK_WRAP_PYTHON=ON \
    -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
    -DVTK_SMP_ENABLE_SEQUENTIAL=ON \
    -DVTK_SMP_ENABLE_STDTHREAD=ON \
    -DVTK_SMP_ENABLE_OPENMP=ON \
    -DVTK_USE_VIDEO_FOR_WINDOWS=ON \
    -DVTK_ENABLE_OSPRAY=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

  # Remove third party CMake patching for older versions than ours
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/patches/3.{1{3,6,9},2{0,2,3}}
  # … as well as duplicate copies
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/vtkm/{Find*.cmake,cmake/{Find*.cmake,3.15}}

}
